=begin
= Ruby/libgraph
binding between "Ruby" and "libgraph".

== Module/Class Hierarchy

  Libgraph -+
            |
            +- Libgraph::MultiBar
            |
            +- Libgraph::Bar
            |
            +- Libgraph::MultiLine
            |
            +- Libgraph::Line
            |
            +- Libgraph::Pie

= Module Libgraph

== CONSTANTS

=== Color

--- Libgraph::BLACK

--- Libgraph::WHITE

--- Libgraph::GREY

--- Libgraph::DKGREY

--- Libgraph::GREEN

--- Libgraph::ORANGE

--- Libgraph::BLUE

--- Libgraph::RED

--- Libgraph::CYAN

--- Libgraph::YELLOW

= Class Libgraph::MultiBar

== Class Methods

--- Libgraph::MultiBar.new(title, width, height, groupsize)
      Create MultiBar Instance. ((|groupsize|)) variable indicates the number
      of columns grouped together.

== Methods

--- Libgraph::MultiBar#set_title(title)
      Set the title.

--- Libgraph::MultiBar#get_title()
      Return the title string.

--- Libgraph::MultiBar#get_size()
      Return the width and height of the graph with ARRAY.

--- Libgraph::MultiBar#set_size(x, y)
      Set the width and height of the graph.

--- Libgraph::MultiBar#get_bg_color()
      Return the background color of graph.

--- Libgraph::MultiBar#set_bg_color(color)
      Set the background color of graph.

--- Libgraph::MultiBar#add_col(name, value)
      Add a set of integer number values for a group of bars with ARRAY, labelled with ((|name|)).

--- Libgraph::MultiBar#add_col_dbl(name, value)
      Add a set of real number values for a group of bars with ARRAY, labelled with ((|name|)).

--- Libgraph::MultiBar#add_pointname(name)
      Add a name for a point or set of points.

--- Libgraph::MultiBar#render()
      Draw the graph.

--- Libgraph::MultiBar#save(name)
      Save the graph with the given name.

= Class Libgraph::Bar

== Class Methods

--- Libgraph::Bar.new(title, width, height)
      Create Bar Instance.

== Methods

--- Libgraph::Bar#set_title(title)
      Set the title.

--- Libgraph::Bar#get_title()
      Return the title string.

--- Libgraph::Bar#get_size()
      Return the width and height of the graph with ARRAY.

--- Libgraph::Bar#set_size(x, y)
      Set the width and height of the graph.

--- Libgraph::Bar#get_bg_color()
      Return the background color of graph.

--- Libgraph::Bar#set_bg_color(color)
      Set the background color of graph.

--- Libgraph::Bar#add_col(name, value)
      Add an integer number ((|value|)) for a bar, labelled with ((|name|)).

--- Libgraph::Bar#add_col_dbl(name, value)
      Add an real number ((|value|)) for a bar, labelled with ((|name|)).

--- Libgraph::Bar#add_pointname(name)
      Add a name for a point or set of points.

--- Libgraph::Bar#render()
      Draw the graph.

--- Libgraph::Bar#save(name)
      Save the graph with the given name.

= Class Libgraph::MultiLine

== Class Methods

--- Libgraph::MultiLine.new(title, width, height, groupsize)
      Create MultiLine Instance. ((|groupsize|)) variable indicates the number
      of columns grouped together.

== Methods

--- Libgraph::MultiLine#set_title(title)
      Set the title.

--- Libgraph::MultiLine#get_title()
      Return the title string.

--- Libgraph::MultiLine#get_size()
      Return the width and height of the graph with ARRAY.

--- Libgraph::MultiLine#set_size(x, y)
      Set the width and height of the graph.

--- Libgraph::MultiLine#get_bg_color()
      Return the background color of graph.

--- Libgraph::MultiLine#set_bg_color(color)
      Set the background color of graph.

--- Libgraph::MultiLine#add_point(name, value)
      Add a set of integer number values with ARRAY, one for each line, labelled with ((|name|)).

--- Libgraph::MultiLine#add_point_dbl(name, value)
      Add a set of real number values with ARRAY, one for each line, labelled with ((|name|)).

--- Libgraph::MultiLine#add_pointname(name)
      Add a name for a point or set of points.

--- Libgraph::MultiLine#render()
      Draw the graph.

--- Libgraph::MultiLine#save(name)
      Save the graph with the given name.

= Class Libgraph::Line

== Class Methods

--- Libgraph::Line.new(title, width, height, groupsize)
      Create Line Instance.

== Methods

--- Libgraph::Line#set_title(title)
      Set the title.

--- Libgraph::Line#get_title()
      Return the title string.

--- Libgraph::Line#get_size()
      Return the width and height of the graph with ARRAY.

--- Libgraph::Line#set_size(x, y)
      Set the width and height of the graph.

--- Libgraph::Line#get_bg_color()
      Return the background color of graph.

--- Libgraph::Line#set_bg_color(color)
      Set the background color of graph.

--- Libgraph::Line#add_point(name, value)
      Add a set of integer number ((|value|)), one for each line, labelled with ((|name|)).

--- Libgraph::Line#add_point_dbl(name, value)
      Add a set of real number ((|value|)), one for each line, labelled with ((|name|)).

--- Libgraph::Line#add_pointname(name)
      Add a name for a point or set of points.

--- Libgraph::Line#render()
      Draw the graph.

--- Libgraph::Line#save(name)
      Save the graph with the given name.

= Class Libgraph::Pie

== Class Methods

--- Libgraph::Pie.new(title, width, height)
      Create Pie Instance.

== Methods

--- Libgraph::Pie#set_title(title)
      Set the title.

--- Libgraph::Pie#get_title()
      Return the title string.

--- Libgraph::Pie#get_size()
      Return the width and height of the graph with ARRAY.

--- Libgraph::Pie#set_size(x, y)
      Set the width and height of the graph.

--- Libgraph::Pie#get_bg_color()
      Return the background color of graph.

--- Libgraph::Pie#set_bg_color(color)
      Set the background color of graph.

--- Libgraph::Pie#add_slice(name, value)
      Add an integer number ((|value|)) for a slice of the pie, labelled with ((|name|)).

--- Libgraph::Pie#add_slice_dbl(name, value)
      Add an real number ((|value|)) for a slice of the pie, labelled with ((|name|)).

--- Libgraph::Pie#add_pointname(name)
      Add a name for a point or set of points.

--- Libgraph::Pie#render()
      Draw the graph.

--- Libgraph::Pie#save(name)
      Save the graph with the given name.

=end
