/*
 * FILE : libgraph_wrap.c
 * 
 * This file was automatically generated by :
 * Simplified Wrapper and Interface Generator (SWIG)
 * Version 1.1 (Patch 5)
 * 
 * Portions Copyright (c) 1995-1998
 * The University of Utah and The Regents of the University of California.
 * Permission is granted to distribute this file in any manner provided
 * this notice remains intact.
 * 
 * Do not make changes to this file--changes will be lost!
 *
 */


#define SWIGCODE
/* Implementation : RUBY */

#define SWIGRUBY
#include "ruby.h"

#define UINT2NUM(v) rb_uint2inum(v)
#define NUM2USHRT(n) NUM2UINT(n)
#define NUM2SHRT(n) (\
    (SHRT_MIN <= NUM2INT(n) && NUM2INT(n) <= SHRT_MAX)\
    ? (short)NUM2INT(n)\
    : (rb_raise(rb_eArgError, "integer %d out of range of `short'",\
               NUM2INT(n)), (short)0)\
)

#ifdef __cplusplus
# define VALUEFUNC(f) ((VALUE (*)(...))f)
# define VOIDFUNC(f) ((void (*)(...))f)
#else
# define VALUEFUNC(f) (f)
# define VOIDFUNC(f) (f)
#endif

/*****************************************************************************
 * $Header:$
 *
 * swigptr.swg
 *
 * This file contains supporting code for the SWIG run-time type checking
 * mechanism.  The following functions are available :
 *
 * SWIG_RegisterMapping(char *origtype, char *newtype, void *(*cast)(void *));
 *
 *      Registers a new type-mapping with the type-checker.  origtype is the
 *      original datatype and newtype is an equivalent type.  cast is optional
 *      pointer to a function to cast pointer values between types (this
 *      is typically used to cast pointers from derived classes to base classes in C++)
 *      
 * SWIG_MakePtr(char *buffer, void *ptr, char *typestring);
 *     
 *      Makes a pointer string from a pointer and typestring.  The result is returned
 *      in buffer which is assumed to hold enough space for the result.
 *
 * char * SWIG_GetPtr(char *buffer, void **ptr, char *type)
 *
 *      Gets a pointer value from a string.  If there is a type-mismatch, returns
 *      a character string to the received type.  On success, returns NULL.
 *
 *
 * You can remap these functions by making a file called "swigptr.swg" in
 * your the same directory as the interface file you are wrapping.
 *
 * These functions are normally declared static, but this file can be
 * can be used in a multi-module environment by redefining the symbol
 * SWIGSTATIC.
 *****************************************************************************/

#include <stdlib.h>

#ifdef SWIG_GLOBAL
#ifdef __cplusplus
#define SWIGSTATIC extern "C"
#else
#define SWIGSTATIC
#endif
#endif

#ifndef SWIGSTATIC
#define SWIGSTATIC static
#endif


/* SWIG pointer structure */

typedef struct SwigPtrType {
  char               *name;               /* Datatype name                  */
  int                 len;                /* Length (used for optimization) */
  void               *(*cast)(void *);    /* Pointer casting function       */
  struct SwigPtrType *next;               /* Linked list pointer            */
} SwigPtrType;

/* Pointer cache structure */

typedef struct {
  int                 stat;               /* Status (valid) bit             */
  SwigPtrType        *tp;                 /* Pointer to type structure      */
  char                name[256];          /* Given datatype name            */
  char                mapped[256];        /* Equivalent name                */
} SwigCacheType;

/* Some variables  */

static int SwigPtrMax  = 64;           /* Max entries that can be currently held */
                                       /* This value may be adjusted dynamically */
static int SwigPtrN    = 0;            /* Current number of entries              */
static int SwigPtrSort = 0;            /* Status flag indicating sort            */
static int SwigStart[256];             /* Starting positions of types            */

/* Pointer table */
static SwigPtrType *SwigPtrTable = 0;  /* Table containing pointer equivalences  */

/* Cached values */

#define SWIG_CACHESIZE  8
#define SWIG_CACHEMASK  0x7
static SwigCacheType SwigCache[SWIG_CACHESIZE];  
static int SwigCacheIndex = 0;
static int SwigLastCache = 0;

/* Sort comparison function */
static int swigsort(const void *data1, const void *data2) {
	SwigPtrType *d1 = (SwigPtrType *) data1;
	SwigPtrType *d2 = (SwigPtrType *) data2;
	return strcmp(d1->name,d2->name);
}

/* Binary Search function */
static int swigcmp(const void *key, const void *data) {
  char *k = (char *) key;
  SwigPtrType *d = (SwigPtrType *) data;
  return strncmp(k,d->name,d->len);
}

/* Register a new datatype with the type-checker */

SWIGSTATIC 
void SWIG_RegisterMapping(char *origtype, char *newtype, void *(*cast)(void *)) {

  int i;
  SwigPtrType *t = 0,*t1;

  /* Allocate the pointer table if necessary */

  if (!SwigPtrTable) {     
    SwigPtrTable = (SwigPtrType *) malloc(SwigPtrMax*sizeof(SwigPtrType));
    SwigPtrN = 0;
  }
  /* Grow the table */
  if (SwigPtrN >= SwigPtrMax) {
    SwigPtrMax = 2*SwigPtrMax;
    SwigPtrTable = (SwigPtrType *) realloc((char *) SwigPtrTable,SwigPtrMax*sizeof(SwigPtrType));
  }
  for (i = 0; i < SwigPtrN; i++)
    if (strcmp(SwigPtrTable[i].name,origtype) == 0) {
      t = &SwigPtrTable[i];
      break;
    }
  if (!t) {
    t = &SwigPtrTable[SwigPtrN];
    t->name = origtype;
    t->len = strlen(t->name);
    t->cast = 0;
    t->next = 0;
    SwigPtrN++;
  }

  /* Check for existing entry */

  while (t->next) {
    if ((strcmp(t->name,newtype) == 0)) {
      if (cast) t->cast = cast;
      return;
    }
    t = t->next;
  }
  
  /* Now place entry (in sorted order) */

  t1 = (SwigPtrType *) malloc(sizeof(SwigPtrType));
  t1->name = newtype;
  t1->len = strlen(t1->name);
  t1->cast = cast;
  t1->next = 0;            
  t->next = t1;           
  SwigPtrSort = 0;
}

/* Make a pointer value string */

SWIGSTATIC 
void SWIG_MakePtr(char *_c, const void *_ptr, char *type) {
  static char _hex[16] =
  {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
   'a', 'b', 'c', 'd', 'e', 'f'};
  unsigned long _p, _s;
  char _result[20], *_r;    /* Note : a 64-bit hex number = 16 digits */
  _r = _result;
  _p = (unsigned long) _ptr;
  if (_p > 0) {
    while (_p > 0) {
      _s = _p & 0xf;
      *(_r++) = _hex[_s];
      _p = _p >> 4;
    }
    *_r = '_';
    while (_r >= _result)
      *(_c++) = *(_r--);
  } else {
    strcpy (_c, "NULL");
  }
  if (_ptr)
    strcpy (_c, type);
}

/* Define for backwards compatibility */

#define _swig_make_hex   SWIG_MakePtr 

/* Function for getting a pointer value */

SWIGSTATIC 
char *SWIG_GetPtr(char *_c, void **ptr, char *_t)
{
  unsigned long _p;
  char temp_type[256];
  char *name;
  int  i, len;
  SwigPtrType *sp,*tp;
  SwigCacheType *cache;
  int  start, end;
  _p = 0;

  /* Pointer values must start with leading underscore */
  if (*_c == '_') {
      _c++;
      /* Extract hex value from pointer */
      while (*_c) {
	  if ((*_c >= '0') && (*_c <= '9'))
	    _p = (_p << 4) + (*_c - '0');
	  else if ((*_c >= 'a') && (*_c <= 'f'))
	    _p = (_p << 4) + ((*_c - 'a') + 10);
	  else
	    break;
	  _c++;
      }

      if (_t) {
	if (strcmp(_t,_c)) { 
	  if (!SwigPtrSort) {
	    qsort((void *) SwigPtrTable, SwigPtrN, sizeof(SwigPtrType), swigsort); 
	    for (i = 0; i < 256; i++) {
	      SwigStart[i] = SwigPtrN;
	    }
	    for (i = SwigPtrN-1; i >= 0; i--) {
	      SwigStart[(int) (SwigPtrTable[i].name[1])] = i;
	    }
	    for (i = 255; i >= 1; i--) {
	      if (SwigStart[i-1] > SwigStart[i])
		SwigStart[i-1] = SwigStart[i];
	    }
	    SwigPtrSort = 1;
	    for (i = 0; i < SWIG_CACHESIZE; i++)  
	      SwigCache[i].stat = 0;
	  }
	  
	  /* First check cache for matches.  Uses last cache value as starting point */
	  cache = &SwigCache[SwigLastCache];
	  for (i = 0; i < SWIG_CACHESIZE; i++) {
	    if (cache->stat) {
	      if (strcmp(_t,cache->name) == 0) {
		if (strcmp(_c,cache->mapped) == 0) {
		  cache->stat++;
		  *ptr = (void *) _p;
		  if (cache->tp->cast) *ptr = (*(cache->tp->cast))(*ptr);
		  return (char *) 0;
		}
	      }
	    }
	    SwigLastCache = (SwigLastCache+1) & SWIG_CACHEMASK;
	    if (!SwigLastCache) cache = SwigCache;
	    else cache++;
	  }
	  /* We have a type mismatch.  Will have to look through our type
	     mapping table to figure out whether or not we can accept this datatype */

	  start = SwigStart[(int) _t[1]];
	  end = SwigStart[(int) _t[1]+1];
	  sp = &SwigPtrTable[start];
	  while (start < end) {
	    if (swigcmp(_t,sp) == 0) break;
	    sp++;
	    start++;
	  }
	  if (start >= end) sp = 0;
	  /* Try to find a match for this */
	  if (sp) {
	    while (swigcmp(_t,sp) == 0) {
	      name = sp->name;
	      len = sp->len;
	      tp = sp->next;
	      /* Try to find entry for our given datatype */
	      while(tp) {
		if (tp->len >= 255) {
		  return _c;
		}
		strcpy(temp_type,tp->name);
		strncat(temp_type,_t+len,255-tp->len);
		if (strcmp(_c,temp_type) == 0) {
		  
		  strcpy(SwigCache[SwigCacheIndex].mapped,_c);
		  strcpy(SwigCache[SwigCacheIndex].name,_t);
		  SwigCache[SwigCacheIndex].stat = 1;
		  SwigCache[SwigCacheIndex].tp = tp;
		  SwigCacheIndex = SwigCacheIndex & SWIG_CACHEMASK;
		  
		  /* Get pointer value */
		  *ptr = (void *) _p;
		  if (tp->cast) *ptr = (*(tp->cast))(*ptr);
		  return (char *) 0;
		}
		tp = tp->next;
	      }
	      sp++;
	      /* Hmmm. Didn't find it this time */
	    }
	  }
	  /* Didn't find any sort of match for this data.  
	     Get the pointer value and return the received type */
	  *ptr = (void *) _p;
	  return _c;
	} else {
	  /* Found a match on the first try.  Return pointer value */
	  *ptr = (void *) _p;
	  return (char *) 0;
	}
      } else {
	/* No type specified.  Good luck */
	*ptr = (void *) _p;
	return (char *) 0;
      }
  } else {
    if (strcmp (_c, "NULL") == 0) {
	*ptr = (void *) 0;
	return (char *) 0;
    }
    *ptr = (void *) 0;	
    return _c;
  }
}

/* Compatibility mode */

#define _swig_get_hex  SWIG_GetPtr

#define SWIG_init    Init_libgraph
#define SWIG_name    "Libgraph"

static VALUE mLibgraph;



#include <libgraph.h>

typedef graphStruct Graph;
typedef graphPieStruct Pie;
typedef graphBarStruct Bar;
typedef graphLineStruct Line;
typedef graphMultiBarStruct MultiBar;
typedef graphMultiLineStruct MultiLine;
extern VALUE cGraph;
extern VALUE cPie;
extern VALUE cBar;
extern VALUE cLine;
extern VALUE cMultiBar;
extern VALUE cMultiLine;

VALUE cGraph;
static void free_Graph(Graph *);
#define Wrap_Graph(klass, ptr) (\
    (ptr) ? Data_Wrap_Struct(klass, 0, free_Graph, ptr) : Qnil )
#define Get_Graph(val, ptr) {\
    if (NIL_P(val)) ptr = NULL;\
    else {\
        if (!rb_obj_is_kind_of(val, cGraph))\
            rb_raise(rb_eTypeError, "wrong argument type (expected Graph)");\
        Data_Get_Struct(val, Graph, ptr);\
        if (!ptr) rb_raise(rb_eRuntimeError, "This Graph already released");\
    }\
}

VALUE cPie;
static void free_Pie(Pie *);
#define Wrap_Pie(klass, ptr) (\
    (ptr) ? Data_Wrap_Struct(klass, 0, free_Pie, ptr) : Qnil )
#define Get_Pie(val, ptr) {\
    if (NIL_P(val)) ptr = NULL;\
    else {\
        if (!rb_obj_is_kind_of(val, cPie))\
            rb_raise(rb_eTypeError, "wrong argument type (expected Pie)");\
        Data_Get_Struct(val, Pie, ptr);\
        if (!ptr) rb_raise(rb_eRuntimeError, "This Pie already released");\
    }\
}

VALUE cBar;
static void free_Bar(Bar *);
#define Wrap_Bar(klass, ptr) (\
    (ptr) ? Data_Wrap_Struct(klass, 0, free_Bar, ptr) : Qnil )
#define Get_Bar(val, ptr) {\
    if (NIL_P(val)) ptr = NULL;\
    else {\
        if (!rb_obj_is_kind_of(val, cBar))\
            rb_raise(rb_eTypeError, "wrong argument type (expected Bar)");\
        Data_Get_Struct(val, Bar, ptr);\
        if (!ptr) rb_raise(rb_eRuntimeError, "This Bar already released");\
    }\
}

VALUE cLine;
static void free_Line(Line *);
#define Wrap_Line(klass, ptr) (\
    (ptr) ? Data_Wrap_Struct(klass, 0, free_Line, ptr) : Qnil )
#define Get_Line(val, ptr) {\
    if (NIL_P(val)) ptr = NULL;\
    else {\
        if (!rb_obj_is_kind_of(val, cLine))\
            rb_raise(rb_eTypeError, "wrong argument type (expected Line)");\
        Data_Get_Struct(val, Line, ptr);\
        if (!ptr) rb_raise(rb_eRuntimeError, "This Line already released");\
    }\
}

VALUE cMultiBar;
static void free_MultiBar(MultiBar *);
#define Wrap_MultiBar(klass, ptr) (\
    (ptr) ? Data_Wrap_Struct(klass, 0, free_MultiBar, ptr) : Qnil )
#define Get_MultiBar(val, ptr) {\
    if (NIL_P(val)) ptr = NULL;\
    else {\
        if (!rb_obj_is_kind_of(val, cMultiBar))\
            rb_raise(rb_eTypeError, "wrong argument type (expected MultiBar)");\
        Data_Get_Struct(val, MultiBar, ptr);\
        if (!ptr) rb_raise(rb_eRuntimeError, "This MultiBar already released");\
    }\
}

VALUE cMultiLine;
static void free_MultiLine(MultiLine *);
#define Wrap_MultiLine(klass, ptr) (\
    (ptr) ? Data_Wrap_Struct(klass, 0, free_MultiLine, ptr) : Qnil )
#define Get_MultiLine(val, ptr) {\
    if (NIL_P(val)) ptr = NULL;\
    else {\
        if (!rb_obj_is_kind_of(val, cMultiLine))\
            rb_raise(rb_eTypeError, "wrong argument type (expected MultiLine)");\
        Data_Get_Struct(val, MultiLine, ptr);\
        if (!ptr) rb_raise(rb_eRuntimeError, "This MultiLine already released");\
    }\
}
static VALUE
_wrap_lg_graph_color_init(VALUE self, VALUE varg0, VALUE varg1) {
    VALUE vresult = Qnil;
    gdImagePtr * _arg0;
    int ** _arg1;

    {
      Check_Type(varg0, T_STRING);
      if (SWIG_GetPtr(RSTRING(varg0)->ptr,(void **) &_arg0, "_gdImagePtr_p")) {
        rb_raise(rb_eTypeError, "Expected a _gdImagePtr_p");
      }
    }
    {
      Check_Type(varg1, T_STRING);
      if (SWIG_GetPtr(RSTRING(varg1)->ptr,(void **) &_arg1, "_int_pp")) {
        rb_raise(rb_eTypeError, "Expected a _int_pp");
      }
    }
    lg_graph_color_init(*_arg0,_arg1);
    return vresult;
}

static VALUE
_wrap_lg_graph_color_next(VALUE self, VALUE varg0) {
    VALUE vresult = Qnil;
    int  _result;
    graphColor  _arg0;

    _arg0 = NUM2INT(varg0);
    _result = (int )lg_graph_color_next(_arg0);
    vresult = INT2NUM(_result);
    return vresult;
}

static Graph *new_Graph(char *title,int width,int height) {
	  lg_graph_new(title, width, height);
	}

static VALUE
_wrap_new_Graph(VALUE self, VALUE varg0, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    Graph * _result;
    char * _arg0;
    int  _arg1;
    int  _arg2;

    _arg0 = STR2CSTR(varg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    _result = (Graph *)new_Graph(_arg0,_arg1,_arg2);
    vresult = Wrap_Graph(self, _result);
    return vresult;
}

static void delete_Graph(Graph *self) {
	  lg_graph_destroy (self);
	}
static void
free_Graph(Graph *ptr) {
    delete_Graph(ptr);
}
static VALUE
_wrap_lg_graph_get_title(VALUE self) {
    VALUE vresult = Qnil;
    char * _result;
    Graph * _arg0;

    Get_Graph(self, _arg0);
    _result = (char *)lg_graph_get_title(_arg0);
    vresult = rb_str_new2(_result);
    return vresult;
}

static VALUE
_wrap_lg_graph_set_title(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Graph * _arg0;
    char * _arg1;

    Get_Graph(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_set_title(_arg0,_arg1);
    return vresult;
}

static VALUE  lg_graph_call_func_get_size(Graph *self) {
	  VALUE ary = rb_ary_new2(2);
	  int x, y;

	  lg_graph_get_size(self, &x, &y);
	  rb_ary_push(ary, INT2FIX(x));
	  rb_ary_push(ary, INT2FIX(y));
	  return ary;
	}
static VALUE
_wrap_lg_graph_call_func_get_size(VALUE self) {
    VALUE vresult = Qnil;
    VALUE  _result;
    Graph * _arg0;

    Get_Graph(self, _arg0);
    _result = (VALUE )lg_graph_call_func_get_size(_arg0);
    vresult = _result;
    return vresult;
}

static VALUE
_wrap_lg_graph_set_size(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    Graph * _arg0;
    int  _arg1;
    int  _arg2;

    Get_Graph(self, _arg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    lg_graph_set_size(_arg0,_arg1,_arg2);
    return vresult;
}

static VALUE
_wrap_lg_graph_get_bg_color(VALUE self) {
    VALUE vresult = Qnil;
    int  _result;
    Graph * _arg0;

    Get_Graph(self, _arg0);
    _result = (int )lg_graph_get_bg_color(_arg0);
    vresult = INT2NUM(_result);
    return vresult;
}

static VALUE
_wrap_lg_graph_set_bg_color(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Graph * _arg0;
    int  _arg1;

    Get_Graph(self, _arg0);
    _arg1 = NUM2INT(varg1);
    lg_graph_set_bg_color(_arg0,_arg1);
    return vresult;
}

static VALUE
_wrap_lg_graph_get_type(VALUE self) {
    VALUE vresult = Qnil;
    graphType * _result;
    Graph * _arg0;

    Get_Graph(self, _arg0);
    _result = (graphType *) malloc(sizeof(graphType ));
    *(_result) = lg_graph_get_type(_arg0);
    {
      char *temp = (char *)malloc(strlen("_graphType")+22);
      SWIG_MakePtr(temp, (void *)_result, "_graphType");
      vresult = rb_str_new2(temp);
      free(temp);
    }
    return vresult;
}

static VALUE
_wrap_lg_graph_set_type(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Graph * _arg0;
    graphType * _arg1;

    Get_Graph(self, _arg0);
    {
      Check_Type(varg1, T_STRING);
      if (SWIG_GetPtr(RSTRING(varg1)->ptr,(void **) &_arg1, "_graphType_p")) {
        rb_raise(rb_eTypeError, "Expected a _graphType_p");
      }
    }
    lg_graph_set_type(_arg0,*_arg1);
    return vresult;
}

static VALUE
_wrap_lg_graph_add_pointname(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    int  _result;
    Graph * _arg0;
    char * _arg1;

    Get_Graph(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _result = (int )lg_graph_add_pointname(_arg0,_arg1);
    vresult = INT2NUM(_result);
    return vresult;
}

static VALUE
_wrap_lg_graph_render(VALUE self) {
    VALUE vresult = Qnil;
    Graph * _arg0;

    Get_Graph(self, _arg0);
    lg_graph_render(_arg0);
    return vresult;
}

static VALUE
_wrap_lg_graph_save(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Graph * _arg0;
    char * _arg1;

    Get_Graph(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_save(_arg0,_arg1);
    return vresult;
}

static Pie *new_Pie(char *title,int width,int height) {
	  lg_graph_pie_new(title, width, height);
	}

static VALUE
_wrap_new_Pie(VALUE self, VALUE varg0, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    Pie * _result;
    char * _arg0;
    int  _arg1;
    int  _arg2;

    _arg0 = STR2CSTR(varg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    _result = (Pie *)new_Pie(_arg0,_arg1,_arg2);
    vresult = Wrap_Pie(self, _result);
    return vresult;
}

static void delete_Pie(Pie *self) {
	  lg_graph_pie_destroy (self);
	}
static void
free_Pie(Pie *ptr) {
    delete_Pie(ptr);
}
static VALUE
_wrap_lg_graph_pie_add_slice(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    int  _result;
    Pie * _arg0;
    char * _arg1;
    int  _arg2;

    Get_Pie(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _arg2 = NUM2INT(varg2);
    _result = (int )lg_graph_pie_add_slice(_arg0,_arg1,_arg2);
    vresult = INT2NUM(_result);
    return vresult;
}

static VALUE
_wrap_lg_graph_pie_add_slice_dbl(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    int  _result;
    Pie * _arg0;
    char * _arg1;
    double  _arg2;

    Get_Pie(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _arg2 = NUM2DBL(varg2);
    _result = (int )lg_graph_pie_add_slice_dbl(_arg0,_arg1,_arg2);
    vresult = INT2NUM(_result);
    return vresult;
}

static VALUE
_wrap_lg_graph_pie_render(VALUE self) {
    VALUE vresult = Qnil;
    Pie * _arg0;

    Get_Pie(self, _arg0);
    lg_graph_pie_render(_arg0);
    return vresult;
}

static char * lg_graph_pie_get_title(Pie *self) {
	  lg_graph_get_title((Graph *)self);
	}
static VALUE
_wrap_lg_graph_pie_get_title(VALUE self) {
    VALUE vresult = Qnil;
    char * _result;
    Pie * _arg0;

    Get_Pie(self, _arg0);
    _result = (char *)lg_graph_pie_get_title(_arg0);
    vresult = rb_str_new2(_result);
    return vresult;
}

static void  lg_graph_pie_set_title(Pie *self,const char * title) {
	  lg_graph_set_title((Graph *)self, title);
	}
static VALUE
_wrap_lg_graph_pie_set_title(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Pie * _arg0;
    char * _arg1;

    Get_Pie(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_pie_set_title(_arg0,_arg1);
    return vresult;
}

static VALUE  lg_graph_pie_call_func_get_size(Pie *self) {
	  VALUE ary = rb_ary_new2(2);
	  int x, y;

	  lg_graph_get_size((Graph *)self, &x, &y);
	  rb_ary_push(ary, INT2FIX(x));
	  rb_ary_push(ary, INT2FIX(y));
	  return ary;
	}
static VALUE
_wrap_lg_graph_pie_call_func_get_size(VALUE self) {
    VALUE vresult = Qnil;
    VALUE  _result;
    Pie * _arg0;

    Get_Pie(self, _arg0);
    _result = (VALUE )lg_graph_pie_call_func_get_size(_arg0);
    vresult = _result;
    return vresult;
}

static void  lg_graph_pie_set_size(Pie *self,int  x,int  y) {
	  lg_graph_set_size((Graph *)self, x, y);
	}
static VALUE
_wrap_lg_graph_pie_set_size(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    Pie * _arg0;
    int  _arg1;
    int  _arg2;

    Get_Pie(self, _arg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    lg_graph_pie_set_size(_arg0,_arg1,_arg2);
    return vresult;
}

static int  lg_graph_pie_get_bg_color(Pie *self) {
	  lg_graph_get_bg_color((Graph *)self);
	}
static VALUE
_wrap_lg_graph_pie_get_bg_color(VALUE self) {
    VALUE vresult = Qnil;
    int  _result;
    Pie * _arg0;

    Get_Pie(self, _arg0);
    _result = (int )lg_graph_pie_get_bg_color(_arg0);
    vresult = INT2NUM(_result);
    return vresult;
}

static void  lg_graph_pie_set_bg_color(Pie *self,int  color) {
	  lg_graph_set_bg_color((Graph *)self, color);
	}
static VALUE
_wrap_lg_graph_pie_set_bg_color(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Pie * _arg0;
    int  _arg1;

    Get_Pie(self, _arg0);
    _arg1 = NUM2INT(varg1);
    lg_graph_pie_set_bg_color(_arg0,_arg1);
    return vresult;
}

static int  lg_graph_pie_add_pointname(Pie *self,char * name) {
	  lg_graph_add_pointname((Graph *)self, name);
	}
static VALUE
_wrap_lg_graph_pie_add_pointname(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    int  _result;
    Pie * _arg0;
    char * _arg1;

    Get_Pie(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _result = (int )lg_graph_pie_add_pointname(_arg0,_arg1);
    vresult = INT2NUM(_result);
    return vresult;
}

static void  lg_graph_pie_save(Pie *self,char * name) {
	  lg_graph_save((Graph *)self, name);
	}
static VALUE
_wrap_lg_graph_pie_save(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Pie * _arg0;
    char * _arg1;

    Get_Pie(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_pie_save(_arg0,_arg1);
    return vresult;
}

static Bar *new_Bar(char *title,int width,int height) {
	  lg_graph_bar_new(title, width, height);
	}

static VALUE
_wrap_new_Bar(VALUE self, VALUE varg0, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    Bar * _result;
    char * _arg0;
    int  _arg1;
    int  _arg2;

    _arg0 = STR2CSTR(varg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    _result = (Bar *)new_Bar(_arg0,_arg1,_arg2);
    vresult = Wrap_Bar(self, _result);
    return vresult;
}

static void delete_Bar(Bar *self) {
	  lg_graph_bar_destroy (self);
	}
static void
free_Bar(Bar *ptr) {
    delete_Bar(ptr);
}
static VALUE
_wrap_lg_graph_bar_add_col(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    int  _result;
    Bar * _arg0;
    char * _arg1;
    int  _arg2;

    Get_Bar(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _arg2 = NUM2INT(varg2);
    _result = (int )lg_graph_bar_add_col(_arg0,_arg1,_arg2);
    vresult = INT2NUM(_result);
    return vresult;
}

static VALUE
_wrap_lg_graph_bar_add_col_dbl(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    int  _result;
    Bar * _arg0;
    char * _arg1;
    double  _arg2;

    Get_Bar(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _arg2 = NUM2DBL(varg2);
    _result = (int )lg_graph_bar_add_col_dbl(_arg0,_arg1,_arg2);
    vresult = INT2NUM(_result);
    return vresult;
}

static VALUE
_wrap_lg_graph_bar_render(VALUE self) {
    VALUE vresult = Qnil;
    Bar * _arg0;

    Get_Bar(self, _arg0);
    lg_graph_bar_render(_arg0);
    return vresult;
}

static char * lg_graph_bar_get_title(Bar *self) {
	  lg_graph_get_title((Graph *)self);
	}
static VALUE
_wrap_lg_graph_bar_get_title(VALUE self) {
    VALUE vresult = Qnil;
    char * _result;
    Bar * _arg0;

    Get_Bar(self, _arg0);
    _result = (char *)lg_graph_bar_get_title(_arg0);
    vresult = rb_str_new2(_result);
    return vresult;
}

static void  lg_graph_bar_set_title(Bar *self,const char * title) {
	  lg_graph_set_title((Graph *)self, title);
	}
static VALUE
_wrap_lg_graph_bar_set_title(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Bar * _arg0;
    char * _arg1;

    Get_Bar(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_bar_set_title(_arg0,_arg1);
    return vresult;
}

static VALUE  lg_graph_bar_call_func_get_size(Bar *self) {
	  VALUE ary = rb_ary_new2(2);
	  int x, y;

	  lg_graph_get_size((Graph *)self, &x, &y);
	  rb_ary_push(ary, INT2FIX(x));
	  rb_ary_push(ary, INT2FIX(y));
	  return ary;
	}
static VALUE
_wrap_lg_graph_bar_call_func_get_size(VALUE self) {
    VALUE vresult = Qnil;
    VALUE  _result;
    Bar * _arg0;

    Get_Bar(self, _arg0);
    _result = (VALUE )lg_graph_bar_call_func_get_size(_arg0);
    vresult = _result;
    return vresult;
}

static void  lg_graph_bar_set_size(Bar *self,int  x,int  y) {
	  lg_graph_set_size((Graph *)self, x, y);
	}
static VALUE
_wrap_lg_graph_bar_set_size(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    Bar * _arg0;
    int  _arg1;
    int  _arg2;

    Get_Bar(self, _arg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    lg_graph_bar_set_size(_arg0,_arg1,_arg2);
    return vresult;
}

static int  lg_graph_bar_get_bg_color(Bar *self) {
	  lg_graph_get_bg_color((Graph *)self);
	}
static VALUE
_wrap_lg_graph_bar_get_bg_color(VALUE self) {
    VALUE vresult = Qnil;
    int  _result;
    Bar * _arg0;

    Get_Bar(self, _arg0);
    _result = (int )lg_graph_bar_get_bg_color(_arg0);
    vresult = INT2NUM(_result);
    return vresult;
}

static void  lg_graph_bar_set_bg_color(Bar *self,int  color) {
	  lg_graph_set_bg_color((Graph *)self, color);
	}
static VALUE
_wrap_lg_graph_bar_set_bg_color(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Bar * _arg0;
    int  _arg1;

    Get_Bar(self, _arg0);
    _arg1 = NUM2INT(varg1);
    lg_graph_bar_set_bg_color(_arg0,_arg1);
    return vresult;
}

static int  lg_graph_bar_add_pointname(Bar *self,char * name) {
	  lg_graph_add_pointname((Graph *)self, name);
	}
static VALUE
_wrap_lg_graph_bar_add_pointname(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    int  _result;
    Bar * _arg0;
    char * _arg1;

    Get_Bar(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _result = (int )lg_graph_bar_add_pointname(_arg0,_arg1);
    vresult = INT2NUM(_result);
    return vresult;
}

static void  lg_graph_bar_save(Bar *self,char * name) {
	  lg_graph_save((Graph *)self, name);
	}
static VALUE
_wrap_lg_graph_bar_save(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Bar * _arg0;
    char * _arg1;

    Get_Bar(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_bar_save(_arg0,_arg1);
    return vresult;
}

static Line *new_Line(char *title,int width,int height) {
	  lg_graph_line_new(title, width, height);
	}

static VALUE
_wrap_new_Line(VALUE self, VALUE varg0, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    Line * _result;
    char * _arg0;
    int  _arg1;
    int  _arg2;

    _arg0 = STR2CSTR(varg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    _result = (Line *)new_Line(_arg0,_arg1,_arg2);
    vresult = Wrap_Line(self, _result);
    return vresult;
}

static void delete_Line(Line *self) {
	  lg_graph_line_destroy (self);
	}
static void
free_Line(Line *ptr) {
    delete_Line(ptr);
}
static VALUE
_wrap_lg_graph_line_add_point(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    int  _result;
    Line * _arg0;
    char * _arg1;
    int  _arg2;

    Get_Line(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _arg2 = NUM2INT(varg2);
    _result = (int )lg_graph_line_add_point(_arg0,_arg1,_arg2);
    vresult = INT2NUM(_result);
    return vresult;
}

static VALUE
_wrap_lg_graph_line_add_point_dbl(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    int  _result;
    Line * _arg0;
    char * _arg1;
    double  _arg2;

    Get_Line(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _arg2 = NUM2DBL(varg2);
    _result = (int )lg_graph_line_add_point_dbl(_arg0,_arg1,_arg2);
    vresult = INT2NUM(_result);
    return vresult;
}

static VALUE
_wrap_lg_graph_line_render(VALUE self) {
    VALUE vresult = Qnil;
    Line * _arg0;

    Get_Line(self, _arg0);
    lg_graph_line_render(_arg0);
    return vresult;
}

static char * lg_graph_line_get_title(Line *self) {
	  lg_graph_get_title((Graph *)self);
	}
static VALUE
_wrap_lg_graph_line_get_title(VALUE self) {
    VALUE vresult = Qnil;
    char * _result;
    Line * _arg0;

    Get_Line(self, _arg0);
    _result = (char *)lg_graph_line_get_title(_arg0);
    vresult = rb_str_new2(_result);
    return vresult;
}

static void  lg_graph_line_set_title(Line *self,const char * title) {
	  lg_graph_set_title((Graph *)self, title);
	}
static VALUE
_wrap_lg_graph_line_set_title(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Line * _arg0;
    char * _arg1;

    Get_Line(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_line_set_title(_arg0,_arg1);
    return vresult;
}

static VALUE  lg_graph_line_call_func_get_size(Line *self) {
	  VALUE ary = rb_ary_new2(2);
	  int x, y;

	  lg_graph_get_size((Graph *)self, &x, &y);
	  rb_ary_push(ary, INT2FIX(x));
	  rb_ary_push(ary, INT2FIX(y));
	  return ary;
	}
static VALUE
_wrap_lg_graph_line_call_func_get_size(VALUE self) {
    VALUE vresult = Qnil;
    VALUE  _result;
    Line * _arg0;

    Get_Line(self, _arg0);
    _result = (VALUE )lg_graph_line_call_func_get_size(_arg0);
    vresult = _result;
    return vresult;
}

static void  lg_graph_line_set_size(Line *self,int  x,int  y) {
	  lg_graph_set_size((Graph *)self, x, y);
	}
static VALUE
_wrap_lg_graph_line_set_size(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    Line * _arg0;
    int  _arg1;
    int  _arg2;

    Get_Line(self, _arg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    lg_graph_line_set_size(_arg0,_arg1,_arg2);
    return vresult;
}

static int  lg_graph_line_get_bg_color(Line *self) {
	  lg_graph_get_bg_color((Graph *)self);
	}
static VALUE
_wrap_lg_graph_line_get_bg_color(VALUE self) {
    VALUE vresult = Qnil;
    int  _result;
    Line * _arg0;

    Get_Line(self, _arg0);
    _result = (int )lg_graph_line_get_bg_color(_arg0);
    vresult = INT2NUM(_result);
    return vresult;
}

static void  lg_graph_line_set_bg_color(Line *self,int  color) {
	  lg_graph_set_bg_color((Graph *)self, color);
	}
static VALUE
_wrap_lg_graph_line_set_bg_color(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Line * _arg0;
    int  _arg1;

    Get_Line(self, _arg0);
    _arg1 = NUM2INT(varg1);
    lg_graph_line_set_bg_color(_arg0,_arg1);
    return vresult;
}

static int  lg_graph_line_add_pointname(Line *self,char * name) {
	  lg_graph_add_pointname((Graph *)self, name);
	}
static VALUE
_wrap_lg_graph_line_add_pointname(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    int  _result;
    Line * _arg0;
    char * _arg1;

    Get_Line(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _result = (int )lg_graph_line_add_pointname(_arg0,_arg1);
    vresult = INT2NUM(_result);
    return vresult;
}

static void  lg_graph_line_save(Line *self,char * name) {
	  lg_graph_save((Graph *)self, name);
	}
static VALUE
_wrap_lg_graph_line_save(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    Line * _arg0;
    char * _arg1;

    Get_Line(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_line_save(_arg0,_arg1);
    return vresult;
}

static MultiBar *new_MultiBar(char *title,int width,int height,int groupsize) {
	  lg_graph_multibar_new(title, width, height, groupsize);
	}

static VALUE
_wrap_new_MultiBar(VALUE self, VALUE varg0, VALUE varg1, VALUE varg2, VALUE varg3) {
    VALUE vresult = Qnil;
    MultiBar * _result;
    char * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;

    _arg0 = STR2CSTR(varg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    _arg3 = NUM2INT(varg3);
    _result = (MultiBar *)new_MultiBar(_arg0,_arg1,_arg2,_arg3);
    vresult = Wrap_MultiBar(self, _result);
    return vresult;
}

static void delete_MultiBar(MultiBar *self) {
	  lg_graph_multibar_destroy (self);
	}
static void
free_MultiBar(MultiBar *ptr) {
    delete_MultiBar(ptr);
}
static VALUE  lg_graph_multibar_call_func_add_col(MultiBar *self,VALUE  name,VALUE  value) {
	  int i, len;
	  int *pnt;

	  Check_Type(value, T_ARRAY);
	  len = RARRAY(value)->len;
	  pnt = ALLOCA_N(int, len);
	  for (i = 0; i < len; i++) {
		pnt[i] = NUM2INT(RARRAY(value)->ptr[i]);
	  }
	  return INT2FIX(lg_graph_multibar_add_col (self, STR2CSTR(name), pnt));
	}
static VALUE
_wrap_lg_graph_multibar_call_func_add_col(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    VALUE  _result;
    MultiBar * _arg0;
    VALUE  _arg1;
    VALUE  _arg2;

    Get_MultiBar(self, _arg0);
    _arg1 = varg1;
    _arg2 = varg2;
    _result = (VALUE )lg_graph_multibar_call_func_add_col(_arg0,_arg1,_arg2);
    vresult = _result;
    return vresult;
}

static VALUE  lg_graph_multibar_call_func_add_col_dbl(MultiBar *self,VALUE  name,VALUE  value) {
	  int i, len;
	  double *pnt;

	  Check_Type(value, T_ARRAY);
	  len = RARRAY(value)->len;
	  pnt = ALLOCA_N(double, len);
	  for (i = 0; i < len; i++) {
		pnt[i] = NUM2DBL(RARRAY(value)->ptr[i]);
	  }
	  return INT2FIX(lg_graph_multibar_add_col_dbl (self, STR2CSTR(name), pnt));
	}
static VALUE
_wrap_lg_graph_multibar_call_func_add_col_dbl(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    VALUE  _result;
    MultiBar * _arg0;
    VALUE  _arg1;
    VALUE  _arg2;

    Get_MultiBar(self, _arg0);
    _arg1 = varg1;
    _arg2 = varg2;
    _result = (VALUE )lg_graph_multibar_call_func_add_col_dbl(_arg0,_arg1,_arg2);
    vresult = _result;
    return vresult;
}

static VALUE
_wrap_lg_graph_multibar_render(VALUE self) {
    VALUE vresult = Qnil;
    MultiBar * _arg0;

    Get_MultiBar(self, _arg0);
    lg_graph_multibar_render(_arg0);
    return vresult;
}

static char * lg_graph_multibar_get_title(MultiBar *self) {
	  lg_graph_get_title((Graph *)self);
	}
static VALUE
_wrap_lg_graph_multibar_get_title(VALUE self) {
    VALUE vresult = Qnil;
    char * _result;
    MultiBar * _arg0;

    Get_MultiBar(self, _arg0);
    _result = (char *)lg_graph_multibar_get_title(_arg0);
    vresult = rb_str_new2(_result);
    return vresult;
}

static void  lg_graph_multibar_set_title(MultiBar *self,const char * title) {
	  lg_graph_set_title((Graph *)self, title);
	}
static VALUE
_wrap_lg_graph_multibar_set_title(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    MultiBar * _arg0;
    char * _arg1;

    Get_MultiBar(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_multibar_set_title(_arg0,_arg1);
    return vresult;
}

static VALUE  lg_graph_multibar_call_func_get_size(MultiBar *self) {
	  VALUE ary = rb_ary_new2(2);
	  int x, y;

	  lg_graph_get_size((Graph *)self, &x, &y);
	  rb_ary_push(ary, INT2FIX(x));
	  rb_ary_push(ary, INT2FIX(y));
	  return ary;
	}
static VALUE
_wrap_lg_graph_multibar_call_func_get_size(VALUE self) {
    VALUE vresult = Qnil;
    VALUE  _result;
    MultiBar * _arg0;

    Get_MultiBar(self, _arg0);
    _result = (VALUE )lg_graph_multibar_call_func_get_size(_arg0);
    vresult = _result;
    return vresult;
}

static void  lg_graph_multibar_set_size(MultiBar *self,int  x,int  y) {
	  lg_graph_set_size((Graph *)self, x, y);
	}
static VALUE
_wrap_lg_graph_multibar_set_size(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    MultiBar * _arg0;
    int  _arg1;
    int  _arg2;

    Get_MultiBar(self, _arg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    lg_graph_multibar_set_size(_arg0,_arg1,_arg2);
    return vresult;
}

static int  lg_graph_multibar_get_bg_color(MultiBar *self) {
	  lg_graph_get_bg_color((Graph *)self);
	}
static VALUE
_wrap_lg_graph_multibar_get_bg_color(VALUE self) {
    VALUE vresult = Qnil;
    int  _result;
    MultiBar * _arg0;

    Get_MultiBar(self, _arg0);
    _result = (int )lg_graph_multibar_get_bg_color(_arg0);
    vresult = INT2NUM(_result);
    return vresult;
}

static void  lg_graph_multibar_set_bg_color(MultiBar *self,int  color) {
	  lg_graph_set_bg_color((Graph *)self, color);
	}
static VALUE
_wrap_lg_graph_multibar_set_bg_color(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    MultiBar * _arg0;
    int  _arg1;

    Get_MultiBar(self, _arg0);
    _arg1 = NUM2INT(varg1);
    lg_graph_multibar_set_bg_color(_arg0,_arg1);
    return vresult;
}

static int  lg_graph_multibar_add_pointname(MultiBar *self,char * name) {
	  lg_graph_add_pointname((Graph *)self, name);
	}
static VALUE
_wrap_lg_graph_multibar_add_pointname(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    int  _result;
    MultiBar * _arg0;
    char * _arg1;

    Get_MultiBar(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _result = (int )lg_graph_multibar_add_pointname(_arg0,_arg1);
    vresult = INT2NUM(_result);
    return vresult;
}

static void  lg_graph_multibar_save(MultiBar *self,char * name) {
	  lg_graph_save((Graph *)self, name);
	}
static VALUE
_wrap_lg_graph_multibar_save(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    MultiBar * _arg0;
    char * _arg1;

    Get_MultiBar(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_multibar_save(_arg0,_arg1);
    return vresult;
}

static MultiLine *new_MultiLine(char *title,int width,int height,int line) {
	  lg_graph_multiline_new(title, width, height, line);
	}

static VALUE
_wrap_new_MultiLine(VALUE self, VALUE varg0, VALUE varg1, VALUE varg2, VALUE varg3) {
    VALUE vresult = Qnil;
    MultiLine * _result;
    char * _arg0;
    int  _arg1;
    int  _arg2;
    int  _arg3;

    _arg0 = STR2CSTR(varg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    _arg3 = NUM2INT(varg3);
    _result = (MultiLine *)new_MultiLine(_arg0,_arg1,_arg2,_arg3);
    vresult = Wrap_MultiLine(self, _result);
    return vresult;
}

static void delete_MultiLine(MultiLine *self) {
	  lg_graph_multiline_destroy (self);
	}
static void
free_MultiLine(MultiLine *ptr) {
    delete_MultiLine(ptr);
}
static VALUE  lg_graph_multiline_call_func_add_point(MultiLine *self,VALUE  name,VALUE  value) {
	  int i, len;
	  int *pnt;

	  Check_Type(value, T_ARRAY);
	  len = RARRAY(value)->len;
	  pnt = ALLOCA_N(int, len);
	  for (i = 0; i < len; i++) {
		pnt[i] = NUM2INT(RARRAY(value)->ptr[i]);
	  }
	  return INT2FIX(lg_graph_multiline_add_point (self, STR2CSTR(name), pnt));
	}
static VALUE
_wrap_lg_graph_multiline_call_func_add_point(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    VALUE  _result;
    MultiLine * _arg0;
    VALUE  _arg1;
    VALUE  _arg2;

    Get_MultiLine(self, _arg0);
    _arg1 = varg1;
    _arg2 = varg2;
    _result = (VALUE )lg_graph_multiline_call_func_add_point(_arg0,_arg1,_arg2);
    vresult = _result;
    return vresult;
}

static VALUE  lg_graph_multiline_call_func_add_point_dbl(MultiLine *self,VALUE  name,VALUE  value) {
	  int i, len;
	  double *pnt;

	  Check_Type(value, T_ARRAY);
	  len = RARRAY(value)->len;
	  pnt = ALLOCA_N(double, len);
	  for (i = 0; i < len; i++) {
		pnt[i] = NUM2INT(RARRAY(value)->ptr[i]);
	  }
	  return INT2FIX(lg_graph_multiline_add_point_dbl (self, STR2CSTR(name), pnt));
	}
static VALUE
_wrap_lg_graph_multiline_call_func_add_point_dbl(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    VALUE  _result;
    MultiLine * _arg0;
    VALUE  _arg1;
    VALUE  _arg2;

    Get_MultiLine(self, _arg0);
    _arg1 = varg1;
    _arg2 = varg2;
    _result = (VALUE )lg_graph_multiline_call_func_add_point_dbl(_arg0,_arg1,_arg2);
    vresult = _result;
    return vresult;
}

static VALUE
_wrap_lg_graph_multiline_render(VALUE self) {
    VALUE vresult = Qnil;
    MultiLine * _arg0;

    Get_MultiLine(self, _arg0);
    lg_graph_multiline_render(_arg0);
    return vresult;
}

static char * lg_graph_multiline_get_title(MultiLine *self) {
	  lg_graph_get_title((Graph *)self);
	}
static VALUE
_wrap_lg_graph_multiline_get_title(VALUE self) {
    VALUE vresult = Qnil;
    char * _result;
    MultiLine * _arg0;

    Get_MultiLine(self, _arg0);
    _result = (char *)lg_graph_multiline_get_title(_arg0);
    vresult = rb_str_new2(_result);
    return vresult;
}

static void  lg_graph_multiline_set_title(MultiLine *self,const char * title) {
	  lg_graph_set_title((Graph *)self, title);
	}
static VALUE
_wrap_lg_graph_multiline_set_title(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    MultiLine * _arg0;
    char * _arg1;

    Get_MultiLine(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_multiline_set_title(_arg0,_arg1);
    return vresult;
}

static VALUE  lg_graph_multiline_call_func_get_size(MultiLine *self) {
	  VALUE ary = rb_ary_new2(2);
	  int x, y;

	  lg_graph_get_size((Graph *)self, &x, &y);
	  rb_ary_push(ary, INT2FIX(x));
	  rb_ary_push(ary, INT2FIX(y));
	  return ary;
	}
static VALUE
_wrap_lg_graph_multiline_call_func_get_size(VALUE self) {
    VALUE vresult = Qnil;
    VALUE  _result;
    MultiLine * _arg0;

    Get_MultiLine(self, _arg0);
    _result = (VALUE )lg_graph_multiline_call_func_get_size(_arg0);
    vresult = _result;
    return vresult;
}

static void  lg_graph_multiline_set_size(MultiLine *self,int  x,int  y) {
	  lg_graph_set_size((Graph *)self, x, y);
	}
static VALUE
_wrap_lg_graph_multiline_set_size(VALUE self, VALUE varg1, VALUE varg2) {
    VALUE vresult = Qnil;
    MultiLine * _arg0;
    int  _arg1;
    int  _arg2;

    Get_MultiLine(self, _arg0);
    _arg1 = NUM2INT(varg1);
    _arg2 = NUM2INT(varg2);
    lg_graph_multiline_set_size(_arg0,_arg1,_arg2);
    return vresult;
}

static int  lg_graph_multiline_get_bg_color(MultiLine *self) {
	  lg_graph_get_bg_color((Graph *)self);
	}
static VALUE
_wrap_lg_graph_multiline_get_bg_color(VALUE self) {
    VALUE vresult = Qnil;
    int  _result;
    MultiLine * _arg0;

    Get_MultiLine(self, _arg0);
    _result = (int )lg_graph_multiline_get_bg_color(_arg0);
    vresult = INT2NUM(_result);
    return vresult;
}

static void  lg_graph_multiline_set_bg_color(MultiLine *self,int  color) {
	  lg_graph_set_bg_color((Graph *)self, color);
	}
static VALUE
_wrap_lg_graph_multiline_set_bg_color(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    MultiLine * _arg0;
    int  _arg1;

    Get_MultiLine(self, _arg0);
    _arg1 = NUM2INT(varg1);
    lg_graph_multiline_set_bg_color(_arg0,_arg1);
    return vresult;
}

static int  lg_graph_multiline_add_pointname(MultiLine *self,char * name) {
	  lg_graph_add_pointname((Graph *)self, name);
	}
static VALUE
_wrap_lg_graph_multiline_add_pointname(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    int  _result;
    MultiLine * _arg0;
    char * _arg1;

    Get_MultiLine(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    _result = (int )lg_graph_multiline_add_pointname(_arg0,_arg1);
    vresult = INT2NUM(_result);
    return vresult;
}

static void  lg_graph_multiline_save(MultiLine *self,char * name) {
	  lg_graph_save((Graph *)self, name);
	}
static VALUE
_wrap_lg_graph_multiline_save(VALUE self, VALUE varg1) {
    VALUE vresult = Qnil;
    MultiLine * _arg0;
    char * _arg1;

    Get_MultiLine(self, _arg0);
    _arg1 = STR2CSTR(varg1);
    lg_graph_multiline_save(_arg0,_arg1);
    return vresult;
}


#ifdef __cplusplus
extern "C"
#endif
void Init_libgraph(void) {
    mLibgraph = rb_define_module("Libgraph");

    rb_define_const(mLibgraph, "DEFAULT", INT2NUM(DEFAULT));
    rb_define_const(mLibgraph, "BLACK", INT2NUM(BLACK));
    rb_define_const(mLibgraph, "WHITE", INT2NUM(WHITE));
    rb_define_const(mLibgraph, "GREY", INT2NUM(GREY));
    rb_define_const(mLibgraph, "DKGREY", INT2NUM(DKGREY));
    rb_define_const(mLibgraph, "GREEN", INT2NUM(GREEN));
    rb_define_const(mLibgraph, "ORANGE", INT2NUM(ORANGE));
    rb_define_const(mLibgraph, "BLUE", INT2NUM(BLUE));
    rb_define_const(mLibgraph, "RED", INT2NUM(RED));
    rb_define_const(mLibgraph, "CYAN", INT2NUM(CYAN));
    rb_define_const(mLibgraph, "YELLOW", INT2NUM(YELLOW));
    rb_define_module_function(mLibgraph, "color_init", _wrap_lg_graph_color_init, 2);
    rb_define_module_function(mLibgraph, "color_next", _wrap_lg_graph_color_next, 1);

    cGraph = rb_define_class_under(mLibgraph, "Graph", rb_cObject);
    rb_define_singleton_method(cGraph, "new", _wrap_new_Graph, 3);
    rb_define_method(cGraph, "get_title", _wrap_lg_graph_get_title, 0);
    rb_define_method(cGraph, "set_title", _wrap_lg_graph_set_title, 1);
    rb_define_method(cGraph, "get_size", _wrap_lg_graph_call_func_get_size, 0);
    rb_define_method(cGraph, "set_size", _wrap_lg_graph_set_size, 2);
    rb_define_method(cGraph, "get_bg_color", _wrap_lg_graph_get_bg_color, 0);
    rb_define_method(cGraph, "set_bg_color", _wrap_lg_graph_set_bg_color, 1);
    rb_define_method(cGraph, "get_type", _wrap_lg_graph_get_type, 0);
    rb_define_method(cGraph, "set_type", _wrap_lg_graph_set_type, 1);
    rb_define_method(cGraph, "add_pointname", _wrap_lg_graph_add_pointname, 1);
    rb_define_method(cGraph, "render", _wrap_lg_graph_render, 0);
    rb_define_method(cGraph, "save", _wrap_lg_graph_save, 1);

    cPie = rb_define_class_under(mLibgraph, "Pie", rb_cObject);
    rb_define_singleton_method(cPie, "new", _wrap_new_Pie, 3);
    rb_define_method(cPie, "add_slice", _wrap_lg_graph_pie_add_slice, 2);
    rb_define_method(cPie, "add_slice_dbl", _wrap_lg_graph_pie_add_slice_dbl, 2);
    rb_define_method(cPie, "render", _wrap_lg_graph_pie_render, 0);
    rb_define_method(cPie, "get_title", _wrap_lg_graph_pie_get_title, 0);
    rb_define_method(cPie, "set_title", _wrap_lg_graph_pie_set_title, 1);
    rb_define_method(cPie, "get_size", _wrap_lg_graph_pie_call_func_get_size, 0);
    rb_define_method(cPie, "set_size", _wrap_lg_graph_pie_set_size, 2);
    rb_define_method(cPie, "get_bg_color", _wrap_lg_graph_pie_get_bg_color, 0);
    rb_define_method(cPie, "set_bg_color", _wrap_lg_graph_pie_set_bg_color, 1);
    rb_define_method(cPie, "add_pointname", _wrap_lg_graph_pie_add_pointname, 1);
    rb_define_method(cPie, "save", _wrap_lg_graph_pie_save, 1);

    cBar = rb_define_class_under(mLibgraph, "Bar", rb_cObject);
    rb_define_singleton_method(cBar, "new", _wrap_new_Bar, 3);
    rb_define_method(cBar, "add_col", _wrap_lg_graph_bar_add_col, 2);
    rb_define_method(cBar, "add_col_dbl", _wrap_lg_graph_bar_add_col_dbl, 2);
    rb_define_method(cBar, "render", _wrap_lg_graph_bar_render, 0);
    rb_define_method(cBar, "get_title", _wrap_lg_graph_bar_get_title, 0);
    rb_define_method(cBar, "set_title", _wrap_lg_graph_bar_set_title, 1);
    rb_define_method(cBar, "get_size", _wrap_lg_graph_bar_call_func_get_size, 0);
    rb_define_method(cBar, "set_size", _wrap_lg_graph_bar_set_size, 2);
    rb_define_method(cBar, "get_bg_color", _wrap_lg_graph_bar_get_bg_color, 0);
    rb_define_method(cBar, "set_bg_color", _wrap_lg_graph_bar_set_bg_color, 1);
    rb_define_method(cBar, "add_pointname", _wrap_lg_graph_bar_add_pointname, 1);
    rb_define_method(cBar, "save", _wrap_lg_graph_bar_save, 1);

    cLine = rb_define_class_under(mLibgraph, "Line", rb_cObject);
    rb_define_singleton_method(cLine, "new", _wrap_new_Line, 3);
    rb_define_method(cLine, "add_point", _wrap_lg_graph_line_add_point, 2);
    rb_define_method(cLine, "add_point_dbl", _wrap_lg_graph_line_add_point_dbl, 2);
    rb_define_method(cLine, "render", _wrap_lg_graph_line_render, 0);
    rb_define_method(cLine, "get_title", _wrap_lg_graph_line_get_title, 0);
    rb_define_method(cLine, "set_title", _wrap_lg_graph_line_set_title, 1);
    rb_define_method(cLine, "get_size", _wrap_lg_graph_line_call_func_get_size, 0);
    rb_define_method(cLine, "set_size", _wrap_lg_graph_line_set_size, 2);
    rb_define_method(cLine, "get_bg_color", _wrap_lg_graph_line_get_bg_color, 0);
    rb_define_method(cLine, "set_bg_color", _wrap_lg_graph_line_set_bg_color, 1);
    rb_define_method(cLine, "add_pointname", _wrap_lg_graph_line_add_pointname, 1);
    rb_define_method(cLine, "save", _wrap_lg_graph_line_save, 1);

    cMultiBar = rb_define_class_under(mLibgraph, "MultiBar", rb_cObject);
    rb_define_singleton_method(cMultiBar, "new", _wrap_new_MultiBar, 4);
    rb_define_method(cMultiBar, "add_col", _wrap_lg_graph_multibar_call_func_add_col, 2);
    rb_define_method(cMultiBar, "add_col_dbl", _wrap_lg_graph_multibar_call_func_add_col_dbl, 2);
    rb_define_method(cMultiBar, "render", _wrap_lg_graph_multibar_render, 0);
    rb_define_method(cMultiBar, "get_title", _wrap_lg_graph_multibar_get_title, 0);
    rb_define_method(cMultiBar, "set_title", _wrap_lg_graph_multibar_set_title, 1);
    rb_define_method(cMultiBar, "get_size", _wrap_lg_graph_multibar_call_func_get_size, 0);
    rb_define_method(cMultiBar, "set_size", _wrap_lg_graph_multibar_set_size, 2);
    rb_define_method(cMultiBar, "get_bg_color", _wrap_lg_graph_multibar_get_bg_color, 0);
    rb_define_method(cMultiBar, "set_bg_color", _wrap_lg_graph_multibar_set_bg_color, 1);
    rb_define_method(cMultiBar, "add_pointname", _wrap_lg_graph_multibar_add_pointname, 1);
    rb_define_method(cMultiBar, "save", _wrap_lg_graph_multibar_save, 1);

    cMultiLine = rb_define_class_under(mLibgraph, "MultiLine", rb_cObject);
    rb_define_singleton_method(cMultiLine, "new", _wrap_new_MultiLine, 4);
    rb_define_method(cMultiLine, "add_point", _wrap_lg_graph_multiline_call_func_add_point, 2);
    rb_define_method(cMultiLine, "add_point_dbl", _wrap_lg_graph_multiline_call_func_add_point_dbl, 2);
    rb_define_method(cMultiLine, "render", _wrap_lg_graph_multiline_render, 0);
    rb_define_method(cMultiLine, "get_title", _wrap_lg_graph_multiline_get_title, 0);
    rb_define_method(cMultiLine, "set_title", _wrap_lg_graph_multiline_set_title, 1);
    rb_define_method(cMultiLine, "get_size", _wrap_lg_graph_multiline_call_func_get_size, 0);
    rb_define_method(cMultiLine, "set_size", _wrap_lg_graph_multiline_set_size, 2);
    rb_define_method(cMultiLine, "get_bg_color", _wrap_lg_graph_multiline_get_bg_color, 0);
    rb_define_method(cMultiLine, "set_bg_color", _wrap_lg_graph_multiline_set_bg_color, 1);
    rb_define_method(cMultiLine, "add_pointname", _wrap_lg_graph_multiline_add_pointname, 1);
    rb_define_method(cMultiLine, "save", _wrap_lg_graph_multiline_save, 1);

/*
 * These are the pointer type-equivalency mappings. 
 * (Used by the SWIG pointer type-checker).
 */
	 SWIG_RegisterMapping("_lg_graph_line","_Line",0);
	 SWIG_RegisterMapping("_lg_graph_line","_struct_lg_graph_line",0);
	 SWIG_RegisterMapping("_signed_long","_long",0);
	 SWIG_RegisterMapping("_lg_graph_multiline","_MultiLine",0);
	 SWIG_RegisterMapping("_lg_graph_multiline","_struct_lg_graph_multiline",0);
	 SWIG_RegisterMapping("_long","_unsigned_long",0);
	 SWIG_RegisterMapping("_long","_signed_long",0);
	 SWIG_RegisterMapping("_Bar","_struct_lg_graph_bar",0);
	 SWIG_RegisterMapping("_Bar","_lg_graph_bar",0);
	 SWIG_RegisterMapping("_Pie","_struct_lg_graph_pie",0);
	 SWIG_RegisterMapping("_Pie","_lg_graph_pie",0);
	 SWIG_RegisterMapping("_Graph","_struct_lg_graph",0);
	 SWIG_RegisterMapping("_Graph","_lg_graph",0);
	 SWIG_RegisterMapping("_struct_lg_graph_line","_Line",0);
	 SWIG_RegisterMapping("_struct_lg_graph_line","_lg_graph_line",0);
	 SWIG_RegisterMapping("_unsigned_long","_long",0);
	 SWIG_RegisterMapping("_lg_graph","_Graph",0);
	 SWIG_RegisterMapping("_lg_graph","_struct_lg_graph",0);
	 SWIG_RegisterMapping("_signed_int","_int",0);
	 SWIG_RegisterMapping("_lg_graph_multibar","_MultiBar",0);
	 SWIG_RegisterMapping("_lg_graph_multibar","_struct_lg_graph_multibar",0);
	 SWIG_RegisterMapping("_unsigned_short","_short",0);
	 SWIG_RegisterMapping("_struct_lg_graph_bar","_Bar",0);
	 SWIG_RegisterMapping("_struct_lg_graph_bar","_lg_graph_bar",0);
	 SWIG_RegisterMapping("_struct_lg_graph_pie","_Pie",0);
	 SWIG_RegisterMapping("_struct_lg_graph_pie","_lg_graph_pie",0);
	 SWIG_RegisterMapping("_signed_short","_short",0);
	 SWIG_RegisterMapping("_MultiBar","_struct_lg_graph_multibar",0);
	 SWIG_RegisterMapping("_MultiBar","_lg_graph_multibar",0);
	 SWIG_RegisterMapping("_lg_graph_bar","_Bar",0);
	 SWIG_RegisterMapping("_lg_graph_bar","_struct_lg_graph_bar",0);
	 SWIG_RegisterMapping("_unsigned_int","_int",0);
	 SWIG_RegisterMapping("_lg_graph_pie","_Pie",0);
	 SWIG_RegisterMapping("_lg_graph_pie","_struct_lg_graph_pie",0);
	 SWIG_RegisterMapping("_short","_unsigned_short",0);
	 SWIG_RegisterMapping("_short","_signed_short",0);
	 SWIG_RegisterMapping("_int","_unsigned_int",0);
	 SWIG_RegisterMapping("_int","_signed_int",0);
	 SWIG_RegisterMapping("_MultiLine","_struct_lg_graph_multiline",0);
	 SWIG_RegisterMapping("_MultiLine","_lg_graph_multiline",0);
	 SWIG_RegisterMapping("_struct_lg_graph_multibar","_MultiBar",0);
	 SWIG_RegisterMapping("_struct_lg_graph_multibar","_lg_graph_multibar",0);
	 SWIG_RegisterMapping("_struct_lg_graph_multiline","_MultiLine",0);
	 SWIG_RegisterMapping("_struct_lg_graph_multiline","_lg_graph_multiline",0);
	 SWIG_RegisterMapping("_struct_lg_graph","_Graph",0);
	 SWIG_RegisterMapping("_struct_lg_graph","_lg_graph",0);
	 SWIG_RegisterMapping("_Line","_struct_lg_graph_line",0);
	 SWIG_RegisterMapping("_Line","_lg_graph_line",0);
}
